#include <TinyGPS++.h>
#include <SoftwareSerial.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27, 20, 4);  // 4x20 LCD on I2C

TinyGPSPlus gps;

SoftwareSerial ss(8, 9);  //Tx/Rx

void setup()
{
  Serial.begin(115200);
  ss.begin(4800); //default baudrate for EM406
  lcd.init();
  lcd.backlight();
  Serial.println("Starting ..."); //debug
}

void loop()
{
  // This sketch displays information every time a new sentence is correctly encoded.
  while (ss.available() > 0)
    if (gps.encode(ss.read()))
      displayLCD();

  if (millis() > 5000 && gps.charsProcessed() < 10)
  {
    Serial.println("No GPS detected: check wiring");
    while(true);
  }
}

void displayLCD()
{    
    lcd.setCursor(0, 0);
    lcd.print("Lat: ");                ///////// Lat
    lcd.print(gps.location.lat(), 6);
    
    lcd.setCursor(0, 1);
    lcd.print("Lon: ");                 ///////// Long
    lcd.print(gps.location.lng(), 6);
    
    lcd.setCursor(0, 2);
    lcd.print("Spd: ");              ///////// Speed
    lcd.print(gps.speed.kmph());
    
    lcd.setCursor(11, 2);
    lcd.print("Hdop: ");              ///////// Hdop - Horizontal Dim. of Precision
    lcd.print(gps.hdop.value());
        
    lcd.setCursor(0, 3);
    lcd.print("Alt: ");               ///////// Altitude
    lcd.print(gps.altitude.meters());
    
    lcd.setCursor(11, 3);
    lcd.print("Sat: ");               ///////// Satellite
    lcd.print(gps.satellites.value()), 2;
    
}
